<center><a href="rich.c">Actual source code: rich.c</a></center><br>

<html>
<head>
<title></title>
<meta name="generator" content="c2html 0.9.5">
<meta name="date" content="2007-03-29T00:29:34+00:00">
</head>

<body bgcolor="#FFFFFF">
<pre width="80"><a name="line1">  1: </a><strong><font color="#228B22">#define PETSCKSP_DLL</font></strong>

<a name="line3">  3: </a><font color="#B22222">/*          </font>
<a name="line4">  4: </a><font color="#B22222">            This implements Richardson Iteration.       </font>
<a name="line5">  5: </a><font color="#B22222">*/</font>
<a name="line6"> 6: </a> #include <A href="../../../../../src/ksp/ksp/kspimpl.h.html">src/ksp/ksp/kspimpl.h</A>
<a name="line7"> 7: </a> #include <A href="../../../../../src/ksp/ksp/impls/rich/richctx.h.html">src/ksp/ksp/impls/rich/richctx.h</A>

<a name="line11"> 11: </a><strong><font color="#4169E1"><a name="KSPSetUp_Richardson"></a><A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> KSPSetUp_Richardson(<A href="../../../../../docs/manualpages/KSP/KSP.html#KSP">KSP</A> ksp)</font></strong>
<a name="line12"> 12: </a>{

<a name="line16"> 16: </a>  <font color="#4169E1">if</font> (ksp-&gt;pc_side == PC_RIGHT) {<A href="../../../../../docs/manualpages/Sys/SETERRQ.html#SETERRQ">SETERRQ</A>(PETSC_ERR_SUP,<font color="#666666">"no right preconditioning for <A href="../../../../../docs/manualpages/KSP/KSPRICHARDSON.html#KSPRICHARDSON">KSPRICHARDSON</A>"</font>);}
<a name="line17"> 17: </a>  <font color="#4169E1">else</font> <font color="#4169E1">if</font> (ksp-&gt;pc_side == PC_SYMMETRIC) {<A href="../../../../../docs/manualpages/Sys/SETERRQ.html#SETERRQ">SETERRQ</A>(PETSC_ERR_SUP,<font color="#666666">"no symmetric preconditioning for <A href="../../../../../docs/manualpages/KSP/KSPRICHARDSON.html#KSPRICHARDSON">KSPRICHARDSON</A>"</font>);}
<a name="line18"> 18: </a>  KSPDefaultGetWork(ksp,2);
<a name="line19"> 19: </a>  <font color="#4169E1">return</font>(0);
<a name="line20"> 20: </a>}

<a name="line24"> 24: </a><strong><font color="#4169E1"><a name="KSPSolve_Richardson"></a><A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>  KSPSolve_Richardson(<A href="../../../../../docs/manualpages/KSP/KSP.html#KSP">KSP</A> ksp)</font></strong>
<a name="line25"> 25: </a>{
<a name="line27"> 27: </a>  <A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>       i,maxit;
<a name="line28"> 28: </a>  <A href="../../../../../docs/manualpages/Mat/MatStructure.html#MatStructure">MatStructure</A>   pflag;
<a name="line29"> 29: </a>  <A href="../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A>      rnorm = 0.0;
<a name="line30"> 30: </a>  <A href="../../../../../docs/manualpages/Sys/PetscScalar.html#PetscScalar">PetscScalar</A>    scale,dt;
<a name="line31"> 31: </a>  <A href="../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A>            x,b,r,z;
<a name="line32"> 32: </a>  <A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>            Amat,Pmat;
<a name="line33"> 33: </a>  KSP_Richardson *richardsonP = (KSP_Richardson*)ksp-&gt;data;
<a name="line34"> 34: </a>  <A href="../../../../../docs/manualpages/Sys/PetscTruth.html#PetscTruth">PetscTruth</A>     exists,diagonalscale;

<a name="line37"> 37: </a>  <A href="../../../../../docs/manualpages/PC/PCDiagonalScale.html#PCDiagonalScale">PCDiagonalScale</A>(ksp-&gt;pc,&amp;diagonalscale);
<a name="line38"> 38: </a>  <font color="#4169E1">if</font> (diagonalscale) <A href="../../../../../docs/manualpages/Sys/SETERRQ1.html#SETERRQ1">SETERRQ1</A>(PETSC_ERR_SUP,<font color="#666666">"Krylov method %s does not support diagonal scaling"</font>,ksp-&gt;type_name);

<a name="line40"> 40: </a>  ksp-&gt;its = 0;

<a name="line42"> 42: </a>  <A href="../../../../../docs/manualpages/PC/PCGetOperators.html#PCGetOperators">PCGetOperators</A>(ksp-&gt;pc,&amp;Amat,&amp;Pmat,&amp;pflag);
<a name="line43"> 43: </a>  x       = ksp-&gt;vec_sol;
<a name="line44"> 44: </a>  b       = ksp-&gt;vec_rhs;
<a name="line45"> 45: </a>  r       = ksp-&gt;work[0];
<a name="line46"> 46: </a>  z       = ksp-&gt;work[1];
<a name="line47"> 47: </a>  maxit   = ksp-&gt;max_it;

<a name="line49"> 49: </a>  <font color="#B22222">/* if user has provided fast Richardson code use that */</font>
<a name="line50"> 50: </a>  <A href="../../../../../docs/manualpages/PC/PCApplyRichardsonExists.html#PCApplyRichardsonExists">PCApplyRichardsonExists</A>(ksp-&gt;pc,&amp;exists);
<a name="line51"> 51: </a>  <font color="#4169E1">if</font> (exists &amp;&amp; !ksp-&gt;numbermonitors &amp;&amp; !ksp-&gt;transpose_solve) {
<a name="line52"> 52: </a>    ksp-&gt;normtype = <A href="../../../../../docs/manualpages/KSP/KSP_NO_NORM.html#KSP_NO_NORM">KSP_NO_NORM</A>;
<a name="line53"> 53: </a>    <A href="../../../../../docs/manualpages/PC/PCApplyRichardson.html#PCApplyRichardson">PCApplyRichardson</A>(ksp-&gt;pc,b,x,r,ksp-&gt;rtol,ksp-&gt;abstol,ksp-&gt;divtol,maxit);
<a name="line54"> 54: </a>    <font color="#4169E1">if</font> (ksp-&gt;normtype != <A href="../../../../../docs/manualpages/KSP/KSP_NO_NORM.html#KSP_NO_NORM">KSP_NO_NORM</A>) {
<a name="line55"> 55: </a>      KSP_MatMult(ksp,Amat,x,r);
<a name="line56"> 56: </a>      <A href="../../../../../docs/manualpages/Vec/VecAYPX.html#VecAYPX">VecAYPX</A>(r,-1.0,b);
<a name="line57"> 57: </a>      <font color="#4169E1">if</font> (ksp-&gt;normtype == <A href="../../../../../docs/manualpages/KSP/KSP_UNPRECONDITIONED_NORM.html#KSP_UNPRECONDITIONED_NORM">KSP_UNPRECONDITIONED_NORM</A> || ksp-&gt;pc_side == PC_RIGHT) {
<a name="line58"> 58: </a>        <A href="../../../../../docs/manualpages/Vec/VecNorm.html#VecNorm">VecNorm</A>(r,<A href="../../../../../docs/manualpages/Vec/NORM_2.html#NORM_2">NORM_2</A>,&amp;rnorm); <font color="#B22222">/*   rnorm &lt;- r'*r     */</font>
<a name="line59"> 59: </a>      } <font color="#4169E1">else</font> {
<a name="line60"> 60: </a>        <A href="../../../../../docs/manualpages/Sys/PetscExceptionTry1.html#PetscExceptionTry1">PetscExceptionTry1</A>((KSP_PCApply(ksp,r,z)),PETSC_ERR_SUP);
<a name="line61"> 61: </a>        <font color="#4169E1">if</font> (<A href="../../../../../docs/manualpages/Sys/PetscExceptionCaught.html#PetscExceptionCaught">PetscExceptionCaught</A>(ierr,PETSC_ERR_SUP)) {
<a name="line62"> 62: </a>          ksp-&gt;reason = <A href="../../../../../docs/manualpages/KSP/KSP_CONVERGED_ITS.html#KSP_CONVERGED_ITS">KSP_CONVERGED_ITS</A>;
<a name="line63"> 63: </a>          <font color="#4169E1">return</font>(0);
<a name="line64"> 64: </a>        }
<a name="line65"> 65: </a>        <font color="#4169E1">if</font> (ksp-&gt;normtype == <A href="../../../../../docs/manualpages/KSP/KSP_PRECONDITIONED_NORM.html#KSP_PRECONDITIONED_NORM">KSP_PRECONDITIONED_NORM</A>) {
<a name="line66"> 66: </a>          <A href="../../../../../docs/manualpages/Vec/VecNorm.html#VecNorm">VecNorm</A>(z,<A href="../../../../../docs/manualpages/Vec/NORM_2.html#NORM_2">NORM_2</A>,&amp;rnorm); <font color="#B22222">/*   rnorm &lt;- r'B'*Br     */</font>
<a name="line67"> 67: </a>        } <font color="#4169E1">else</font> {
<a name="line68"> 68: </a>          <A href="../../../../../docs/manualpages/Vec/VecDot.html#VecDot">VecDot</A>(r,z,&amp;dt);
<a name="line69"> 69: </a>          rnorm = PetscAbsScalar(dt);                    <font color="#B22222">/*   rnorm &lt;- z'*r  = r'Br = e'*A'*B*A*e  */</font>
<a name="line70"> 70: </a>        }
<a name="line71"> 71: </a>      }
<a name="line72"> 72: </a>      (*ksp-&gt;converged)(ksp,0,rnorm,&amp;ksp-&gt;reason,ksp-&gt;cnvP);
<a name="line73"> 73: </a>    }
<a name="line74"> 74: </a>    <font color="#4169E1">if</font> (!ksp-&gt;reason) ksp-&gt;reason = <A href="../../../../../docs/manualpages/KSP/KSP_CONVERGED_ITS.html#KSP_CONVERGED_ITS">KSP_CONVERGED_ITS</A>;
<a name="line75"> 75: </a>    <font color="#4169E1">return</font>(0);
<a name="line76"> 76: </a>  }

<a name="line78"> 78: </a>  scale   = richardsonP-&gt;scale;

<a name="line80"> 80: </a>  <font color="#4169E1">if</font> (!ksp-&gt;guess_zero) {                          <font color="#B22222">/*   r &lt;- b - A x     */</font>
<a name="line81"> 81: </a>    KSP_MatMult(ksp,Amat,x,r);
<a name="line82"> 82: </a>    <A href="../../../../../docs/manualpages/Vec/VecAYPX.html#VecAYPX">VecAYPX</A>(r,-1.0,b);
<a name="line83"> 83: </a>  } <font color="#4169E1">else</font> {
<a name="line84"> 84: </a>    <A href="../../../../../docs/manualpages/Vec/VecCopy.html#VecCopy">VecCopy</A>(b,r);
<a name="line85"> 85: </a>  }

<a name="line87"> 87: </a>  <font color="#4169E1">for</font> (i=0; i&lt;maxit; i++) {
<a name="line88"> 88: </a>    PetscObjectTakeAccess(ksp);
<a name="line89"> 89: </a>    ksp-&gt;its++;
<a name="line90"> 90: </a>    PetscObjectGrantAccess(ksp);

<a name="line92"> 92: </a>    <font color="#4169E1">if</font> (ksp-&gt;normtype == <A href="../../../../../docs/manualpages/KSP/KSP_UNPRECONDITIONED_NORM.html#KSP_UNPRECONDITIONED_NORM">KSP_UNPRECONDITIONED_NORM</A>) {
<a name="line93"> 93: </a>      <A href="../../../../../docs/manualpages/Vec/VecNorm.html#VecNorm">VecNorm</A>(r,<A href="../../../../../docs/manualpages/Vec/NORM_2.html#NORM_2">NORM_2</A>,&amp;rnorm); <font color="#B22222">/*   rnorm &lt;- r'*r     */</font>
<a name="line94"> 94: </a>      KSPMonitor(ksp,i,rnorm);
<a name="line95"> 95: </a>    }

<a name="line97"> 97: </a>    KSP_PCApply(ksp,r,z);    <font color="#B22222">/*   z &lt;- B r          */</font>

<a name="line99"> 99: </a>    <font color="#4169E1">if</font> (ksp-&gt;normtype == <A href="../../../../../docs/manualpages/KSP/KSP_PRECONDITIONED_NORM.html#KSP_PRECONDITIONED_NORM">KSP_PRECONDITIONED_NORM</A>) {
<a name="line100">100: </a>      <A href="../../../../../docs/manualpages/Vec/VecNorm.html#VecNorm">VecNorm</A>(z,<A href="../../../../../docs/manualpages/Vec/NORM_2.html#NORM_2">NORM_2</A>,&amp;rnorm); <font color="#B22222">/*   rnorm &lt;- z'*z     */</font>
<a name="line101">101: </a>      KSPMonitor(ksp,i,rnorm);
<a name="line102">102: </a>    }

<a name="line104">104: </a>    <A href="../../../../../docs/manualpages/Vec/VecAXPY.html#VecAXPY">VecAXPY</A>(x,scale,z);    <font color="#B22222">/*   x  &lt;- x + scale z */</font>
<a name="line105">105: </a>    <font color="#4169E1">if</font> (ksp-&gt;normtype != <A href="../../../../../docs/manualpages/KSP/KSP_NO_NORM.html#KSP_NO_NORM">KSP_NO_NORM</A>) {
<a name="line106">106: </a>      PetscObjectTakeAccess(ksp);
<a name="line107">107: </a>      ksp-&gt;rnorm = rnorm;
<a name="line108">108: </a>      PetscObjectGrantAccess(ksp);
<a name="line109">109: </a>      KSPLogResidualHistory(ksp,rnorm);

<a name="line111">111: </a>      (*ksp-&gt;converged)(ksp,i,rnorm,&amp;ksp-&gt;reason,ksp-&gt;cnvP);
<a name="line112">112: </a>      <font color="#4169E1">if</font> (ksp-&gt;reason) <font color="#4169E1">break</font>;
<a name="line113">113: </a>    }
<a name="line114">114: </a>
<a name="line115">115: </a>    KSP_MatMult(ksp,Amat,x,r);      <font color="#B22222">/*   r  &lt;- b - Ax      */</font>
<a name="line116">116: </a>    <A href="../../../../../docs/manualpages/Vec/VecAYPX.html#VecAYPX">VecAYPX</A>(r,-1.0,b);
<a name="line117">117: </a>  }
<a name="line118">118: </a>  <font color="#4169E1">if</font> (!ksp-&gt;reason) {
<a name="line119">119: </a>    ksp-&gt;reason = <A href="../../../../../docs/manualpages/KSP/KSP_DIVERGED_ITS.html#KSP_DIVERGED_ITS">KSP_DIVERGED_ITS</A>;
<a name="line120">120: </a>    <font color="#4169E1">if</font> (ksp-&gt;normtype != <A href="../../../../../docs/manualpages/KSP/KSP_NO_NORM.html#KSP_NO_NORM">KSP_NO_NORM</A>) {
<a name="line121">121: </a>      <font color="#4169E1">if</font> (ksp-&gt;normtype == <A href="../../../../../docs/manualpages/KSP/KSP_UNPRECONDITIONED_NORM.html#KSP_UNPRECONDITIONED_NORM">KSP_UNPRECONDITIONED_NORM</A>){
<a name="line122">122: </a>        <A href="../../../../../docs/manualpages/Vec/VecNorm.html#VecNorm">VecNorm</A>(r,<A href="../../../../../docs/manualpages/Vec/NORM_2.html#NORM_2">NORM_2</A>,&amp;rnorm);     <font color="#B22222">/*   rnorm &lt;- r'*r     */</font>
<a name="line123">123: </a>      } <font color="#4169E1">else</font> {
<a name="line124">124: </a>        KSP_PCApply(ksp,r,z);   <font color="#B22222">/*   z &lt;- B r          */</font>
<a name="line125">125: </a>        <A href="../../../../../docs/manualpages/Vec/VecNorm.html#VecNorm">VecNorm</A>(z,<A href="../../../../../docs/manualpages/Vec/NORM_2.html#NORM_2">NORM_2</A>,&amp;rnorm);     <font color="#B22222">/*   rnorm &lt;- z'*z     */</font>
<a name="line126">126: </a>      }
<a name="line127">127: </a>    }
<a name="line128">128: </a>    PetscObjectTakeAccess(ksp);
<a name="line129">129: </a>    ksp-&gt;rnorm = rnorm;
<a name="line130">130: </a>    PetscObjectGrantAccess(ksp);
<a name="line131">131: </a>    KSPLogResidualHistory(ksp,rnorm);
<a name="line132">132: </a>    KSPMonitor(ksp,i,rnorm);
<a name="line133">133: </a>    i--;
<a name="line134">134: </a>  } <font color="#4169E1">else</font> <font color="#4169E1">if</font> (!ksp-&gt;reason) {
<a name="line135">135: </a>    ksp-&gt;reason = <A href="../../../../../docs/manualpages/KSP/KSP_DIVERGED_ITS.html#KSP_DIVERGED_ITS">KSP_DIVERGED_ITS</A>;
<a name="line136">136: </a>  }

<a name="line138">138: </a>  <font color="#4169E1">return</font>(0);
<a name="line139">139: </a>}

<a name="line143">143: </a><strong><font color="#4169E1"><a name="KSPView_Richardson"></a><A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> KSPView_Richardson(<A href="../../../../../docs/manualpages/KSP/KSP.html#KSP">KSP</A> ksp,<A href="../../../../../docs/manualpages/Viewer/PetscViewer.html#PetscViewer">PetscViewer</A> viewer)</font></strong>
<a name="line144">144: </a>{
<a name="line145">145: </a>  KSP_Richardson *richardsonP = (KSP_Richardson*)ksp-&gt;data;
<a name="line147">147: </a>  <A href="../../../../../docs/manualpages/Sys/PetscTruth.html#PetscTruth">PetscTruth</A>     iascii;

<a name="line150">150: </a>  <A href="../../../../../docs/manualpages/Sys/PetscTypeCompare.html#PetscTypeCompare">PetscTypeCompare</A>((<A href="../../../../../docs/manualpages/Sys/PetscObject.html#PetscObject">PetscObject</A>)viewer,PETSC_VIEWER_ASCII,&amp;iascii);
<a name="line151">151: </a>  <font color="#4169E1">if</font> (iascii) {
<a name="line152">152: </a>    <A href="../../../../../docs/manualpages/Viewer/PetscViewerASCIIPrintf.html#PetscViewerASCIIPrintf">PetscViewerASCIIPrintf</A>(viewer,<font color="#666666">"  Richardson: damping factor=%G\n"</font>,richardsonP-&gt;scale);
<a name="line153">153: </a>  } <font color="#4169E1">else</font> {
<a name="line154">154: </a>    <A href="../../../../../docs/manualpages/Sys/SETERRQ1.html#SETERRQ1">SETERRQ1</A>(PETSC_ERR_SUP,<font color="#666666">"Viewer type %s not supported for <A href="../../../../../docs/manualpages/KSP/KSP.html#KSP">KSP</A> Richardson"</font>,((<A href="../../../../../docs/manualpages/Sys/PetscObject.html#PetscObject">PetscObject</A>)viewer)-&gt;type_name);
<a name="line155">155: </a>  }
<a name="line156">156: </a>  <font color="#4169E1">return</font>(0);
<a name="line157">157: </a>}

<a name="line161">161: </a><strong><font color="#4169E1"><a name="KSPSetFromOptions_Richardson"></a><A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> KSPSetFromOptions_Richardson(<A href="../../../../../docs/manualpages/KSP/KSP.html#KSP">KSP</A> ksp)</font></strong>
<a name="line162">162: </a>{
<a name="line163">163: </a>  KSP_Richardson *rich = (KSP_Richardson*)ksp-&gt;data;
<a name="line165">165: </a>  <A href="../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A>      tmp;
<a name="line166">166: </a>  <A href="../../../../../docs/manualpages/Sys/PetscTruth.html#PetscTruth">PetscTruth</A>     flg;

<a name="line169">169: </a>  <A href="../../../../../docs/manualpages/Sys/PetscOptionsHead.html#PetscOptionsHead">PetscOptionsHead</A>(<font color="#666666">"<A href="../../../../../docs/manualpages/KSP/KSP.html#KSP">KSP</A> Richardson Options"</font>);
<a name="line170">170: </a>    <A href="../../../../../docs/manualpages/Sys/PetscOptionsReal.html#PetscOptionsReal">PetscOptionsReal</A>(<font color="#666666">"-ksp_richardson_scale"</font>,<font color="#666666">"damping factor"</font>,<font color="#666666">"<A href="../../../../../docs/manualpages/KSP/KSPRichardsonSetScale.html#KSPRichardsonSetScale">KSPRichardsonSetScale</A>"</font>,rich-&gt;scale,&amp;tmp,&amp;flg);
<a name="line171">171: </a>    <font color="#4169E1">if</font> (flg) { <A href="../../../../../docs/manualpages/KSP/KSPRichardsonSetScale.html#KSPRichardsonSetScale">KSPRichardsonSetScale</A>(ksp,tmp); }
<a name="line172">172: </a>  <A href="../../../../../docs/manualpages/Sys/PetscOptionsTail.html#PetscOptionsTail">PetscOptionsTail</A>();
<a name="line173">173: </a>  <font color="#4169E1">return</font>(0);
<a name="line174">174: </a>}

<a name="line179">179: </a><strong><font color="#4169E1"><a name="KSPRichardsonSetScale_Richardson"></a><A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>  KSPRichardsonSetScale_Richardson(<A href="../../../../../docs/manualpages/KSP/KSP.html#KSP">KSP</A> ksp,<A href="../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A> scale)</font></strong>
<a name="line180">180: </a>{
<a name="line181">181: </a>  KSP_Richardson *richardsonP;

<a name="line184">184: </a>  richardsonP = (KSP_Richardson*)ksp-&gt;data;
<a name="line185">185: </a>  richardsonP-&gt;scale = scale;
<a name="line186">186: </a>  <font color="#4169E1">return</font>(0);
<a name="line187">187: </a>}

<a name="line190">190: </a><font color="#B22222">/*MC</font>
<a name="line191">191: </a><font color="#B22222">     <A href="../../../../../docs/manualpages/KSP/KSPRICHARDSON.html#KSPRICHARDSON">KSPRICHARDSON</A> - The preconditioned Richardson iterative method</font>

<a name="line193">193: </a><font color="#B22222">   Options Database Keys:</font>
<a name="line194">194: </a><font color="#B22222">.   -ksp_richardson_scale - damping factor on the correction (defaults to 1.0)</font>

<a name="line196">196: </a><font color="#B22222">   Level: beginner</font>

<a name="line198">198: </a><font color="#B22222">   Notes: x^{n+1} = x^{n} + scale*B(b - A x^{n})</font>

<a name="line200">200: </a><font color="#B22222">          This method often (usually) will not converge unless scale is very small</font>

<a name="line202">202: </a><font color="#B22222">.seealso:  <A href="../../../../../docs/manualpages/KSP/KSPCreate.html#KSPCreate">KSPCreate</A>(), <A href="../../../../../docs/manualpages/KSP/KSPSetType.html#KSPSetType">KSPSetType</A>(), <A href="../../../../../docs/manualpages/KSP/KSPType.html#KSPType">KSPType</A> (for list of available types), <A href="../../../../../docs/manualpages/KSP/KSP.html#KSP">KSP</A>,</font>
<a name="line203">203: </a><font color="#B22222">           <A href="../../../../../docs/manualpages/KSP/KSPRichardsonSetScale.html#KSPRichardsonSetScale">KSPRichardsonSetScale</A>()</font>

<a name="line205">205: </a><font color="#B22222">M*/</font>

<a name="line210">210: </a><strong><font color="#4169E1"><a name="KSPCreate_Richardson"></a><A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>  KSPCreate_Richardson(<A href="../../../../../docs/manualpages/KSP/KSP.html#KSP">KSP</A> ksp)</font></strong>
<a name="line211">211: </a>{
<a name="line213">213: </a>  KSP_Richardson *richardsonP;

<a name="line216">216: </a>  <A href="../../../../../docs/manualpages/Sys/PetscNew.html#PetscNew">PetscNew</A>(KSP_Richardson,&amp;richardsonP);
<a name="line217">217: </a>  PetscLogObjectMemory(ksp,<font color="#4169E1">sizeof</font>(KSP_Richardson));
<a name="line218">218: </a>  ksp-&gt;data                        = (void*)richardsonP;
<a name="line219">219: </a>  richardsonP-&gt;scale               = 1.0;
<a name="line220">220: </a>  ksp-&gt;ops-&gt;setup                  = KSPSetUp_Richardson;
<a name="line221">221: </a>  ksp-&gt;ops-&gt;solve                  = KSPSolve_Richardson;
<a name="line222">222: </a>  ksp-&gt;ops-&gt;destroy                = KSPDefaultDestroy;
<a name="line223">223: </a>  ksp-&gt;ops-&gt;buildsolution          = KSPDefaultBuildSolution;
<a name="line224">224: </a>  ksp-&gt;ops-&gt;buildresidual          = KSPDefaultBuildResidual;
<a name="line225">225: </a>  ksp-&gt;ops-&gt;view                   = KSPView_Richardson;
<a name="line226">226: </a>  ksp-&gt;ops-&gt;setfromoptions         = KSPSetFromOptions_Richardson;

<a name="line228">228: </a>  <A href="../../../../../docs/manualpages/Sys/PetscObjectComposeFunctionDynamic.html#PetscObjectComposeFunctionDynamic">PetscObjectComposeFunctionDynamic</A>((<A href="../../../../../docs/manualpages/Sys/PetscObject.html#PetscObject">PetscObject</A>)ksp,<font color="#666666">"KSPRichardsonSetScale_C"</font>,
<a name="line229">229: </a>                                    <font color="#666666">"KSPRichardsonSetScale_Richardson"</font>,
<a name="line230">230: </a>                                    KSPRichardsonSetScale_Richardson);
<a name="line231">231: </a>  <font color="#4169E1">return</font>(0);
<a name="line232">232: </a>}


</pre>
</body>

</html>
